'use strict';

var PageController = angular.module('PageController', []);

PageController.controller('PageCtrl', ['$scope', '$filter', '$location', '$window', 'Cliente', 'Construcao', 'Compra', 'Notificacao', 'CacheApp',
  ($scope, $filter, $location, $window, Cliente, Construcao, Compra, Notificacao, CacheApp) => {

    $scope.sessao = CacheApp.getSessao();

    $scope.construcaoSelecionada = false;

    $scope.PerguntaSimNao = '';
    $scope.QuantidadePedido = 0;

    $scope.AtualizaConstrucao = () => {
        // $scope.construcao = CacheApp.getConstrucao();
        // $scope.construcaoSelecionada = $scope.construcao ? true : false;
    }
    // $scope.AtualizaConstrucao();

    $scope.AtualizaSessaoPage = () => {
        $scope.sessao = CacheApp.getSessao();
    }

    $scope.closeMenu = (menu) => {
        if (menu) {
            $('.hamburger').trigger('click');
        }
    }

    $scope.getListaObraCache = (paramsObra, callBack) => {
        function getListaObra(callBack) {
            var sessao = CacheApp.getSessao()
            var params = {
                Tipo: 0, 
                IdClienteAdmin: sessao.ContaAdmin ? sessao.IdClienteAdmin : undefined,
                IdConstrucao: paramsObra.IdConstrucao ? paramsObra.IdConstrucao : undefined 
            }
            Construcao.getListaObras(params,
                (data) => {
                    console.log('CALLLL!')
                    $scope.construcoesCache = []
                    $scope.construcoesCache = data.Instance
                    callBack($scope.construcoesCache)
                }
            );
        }

        if (!$scope.construcoesCache)
            paramsObra.refresh = true

        if (paramsObra.refresh)
            getListaObra(
                (construcoes) => {
                    callBack(!paramsObra.permissao ? construcoes : construcoes.filter(c => c.Acessos && c.Acessos.some(a => paramsObra.permissao.split(',').some(as => as == a))))
                }
            )
        else
            callBack(!paramsObra.permissao ? $scope.construcoesCache : $scope.construcoesCache.filter(c => c.Acessos && c.Acessos.some(a => paramsObra.permissao.split(',').some(as => as == a))))

    }

    $scope.AcessoAndroid = (params, callBackFunction) => {
        var init = 'app/mvc/main.html#/';
        var url = $location.absUrl().split('?')[0];
        var path = url.substring(url.indexOf(init)+init.length);
        var notPahts = ['',
            'dashboard',
            'listaalmoxarifado/geral',
            'solicitacaoworkflow/geral',
            'notificacaocomrpas/geral',
            'extrato',
            'compartilhamento',
            'perfil',
            'construcao/manter',
            'listanotafiscal/geral',
            'notafiscal/manter/debito',
            'notafiscal/manter/credito',
            'listanfsefaz',
            'listafornecedor',
            'listanotificacao'
        ]
        if (!notPahts.some(p => path.indexOf(p) >= 0))//p == path))
            if(!$scope.construcao) {
                if ($scope.sessao)
                    $location.path('/');
                else
                    $window.location.href = '../index.html';

                return;
            }

        if (params.chave) {
            CacheApp.setSessao({ Chave: params.chave });
            Cliente.getSessaoValida((data) => {

                data.Instance.AndroidAccess = true;
                $scope.sessao = data.Instance;
                CacheApp.setSessao($scope.sessao);

                if (params.idconstrucao) {
                    var params = { 
                        Tipo: 1, 
                        IdClienteAdmin: $scope.sessao.ContaAdmin ? $scope.sessao.IdClienteAdmin : undefined,
                        IdConstrucao: params.idconstrucao
                    }
                    Construcao.getConstrucoes(params,
                    (data) => {
                        CacheApp.setConstrucao(data.Instance[0]);

                        if (params.idcomprovante) {
                            Compra.getComprovante(params.idcomprovante,
                                (data) => {
                                    CacheApp.setNotaFiscal(data.Instance);
                                    callBackFunction(true);
                                });
                        }
                        else
                            callBackFunction(true);
                    });
                }
                else
                callBackFunction(true);
            });
        }
        else {
            if ($scope.sessao) {
                $scope.sessao.AndroidAccess = $scope.sessao.AndroidAccess;
                CacheApp.setSessao($scope.sessao);
                callBackFunction(false);
            }
            else
                $window.location.href = '../index.html';
        }
    }
    
    $scope.respostaSim = () => {
        $scope.PerguntaSimNao = 'S';
    }
    $scope.respostaNao = () => {
        $scope.PerguntaSimNao = 'N';
    }

    $scope.msgBoxPergunta = (title, msg, usedFunctionSim, usedFunctionNao) => {
        swal({
            title: title,
            text: msg,
            type: 'question',
            showCancelButton: true,
            confirmButtonColor: '#263143',
            cancelButtonColor: '#F6A000',
            confirmButtonText: 'Sim',
            cancelButtonText: "Não"
            }).then((result) => {
            if (result.value)
                usedFunctionSim();
            else
                usedFunctionNao();
            });
    }

    $scope.msgBoxSucesso = (title, msg, usedFunctionOk) => {
        swal(
            title,
            msg,
            'success'
            ).then((result) => {
            usedFunctionOk();
            });
    }

    $scope.msgBoxAtencao = (title, msg, usedFunctionOk) => {
        swal(
            title,
            msg,
            'warning'
            ).then((result) => {
            usedFunctionOk();
            });
    }

    $scope.msgBoxErro = (title, msg, usedFunctionOk) => {
        swal(
            title,
            msg,
            'error'
            ).then((result) => {
            usedFunctionOk();
            });
    }

    $scope.msgBoxModal = (title, msg, tipo, usedFunctionOk) => {

        $('#lbTitulo').html(title);
        $('#MsgSucesso').html(msg);
        $('#MsgPanel').addClass(tipo == 0 ? 'panel-blue' : (tipo == 1 ? 'panel-orange' : 'panel-executar'));
        $('#BoxMensagem').modal('show');

        $('#BoxMensagem').on('hide.bs.modal', (e) => {
            $('#BoxMensagem').off('hide.bs.modal');
            usedFunctionOk();
        });
    }

    $scope.showVideoModal = (codigo) => {
        CacheApp.setCountBack();
        var src = 'https://www.youtube.com/embed/' + codigo;
        var css = {
            'maxWidth': $(window).width() - 100,
            'maxHeight': $(window).height() - 100
        };

        var $lightbox = $('#boxvideomodal');
        $lightbox.find('iframe').attr('src', src);
        $lightbox.find('iframe').css(css);
        $lightbox.on('shown.bs.modal', (e) => {
            var $img = $lightbox.find('iframe');
            $lightbox.find('.modal-dialog').css({ 'width': $img.width() });
        });

        $lightbox.on('hide.bs.modal', (e) => {
            $lightbox.find('iframe').attr('src', '');
            $lightbox.off('hide.bs.modal');
        });

        $lightbox.modal('show');
    }

    $scope.excluirAcesso = () => {
        $scope.msgBoxPergunta($scope.construcao.Titulo, 'Confirma exclusão da ' + $scope.construcao.TipoDescricao + '?'
            , () => {
                var cliente = { IdCliente: $scope.sessao.IdCliente, IdConstrucao: $scope.construcao.Id };
                Construcao.delAcessosConstrucao(cliente,
                    (data) => {
                        $location.path("/");
                    });
            }
            , () => {
            });
    }

    $scope.excluirConstrucao = (construcao) => {
        $scope.msgBoxPergunta($scope.construcao.Titulo, 'Confirma exclusão da ' + $scope.construcao.TipoDescricao + '?'
            , () => {
                Construcao.delConstrucao($scope.construcao.Id,
                    (data) => {
                        //setTimeout(() { $location.path("/"); }, 2000)=> ;
                        $location.path("/");
                    });
            }
            , () => {
            });
    }

    $scope.CopiarColarConstrucao = () => {
        var params = { 
            IdConstrucao: $scope.construcao.Id,
            IdClienteAdmin: $scope.construcao.IdClienteDono
        }
        Construcao.clonarConstrucao(params,
            (data) => {
            setTimeout(() => { $location.path("/"); }, 500)
            });
    }

    $scope.finalizarConstrucao = () => {
        $scope.msgBoxPergunta('Finalizar ' + $scope.construcao.Titulo, 'Sua ' + $scope.construcao.TipoDescricao + ' ficará disponível somente para consulta, confirma a finalização?'
            , () => {

                swal({
                    title: 'Data de Finalização',
                    html: '<input type="date" class="input-lg" id="DataFinalizada" datasafari />',
                    showCancelButton: true,
                    confirmButtonColor: '#263143',
                    cancelButtonColor: '#F6A000',
                    confirmButtonText: 'Salvar',
                    cancelButtonText: "Cancelar",
                    onOpen: () => {
                        $('#DataFinalizada').val( $filter("date")(new Date(), 'yyyy-MM-dd') );
                    }
                    }).then((result) => {
                        if (result.value) {
                            Construcao.finalizarConstrucao($scope.construcao.Id, $('#DataFinalizada').val()+' 03:05:00',
                                (data) => {
                                    $scope.msgBoxSucesso($scope.construcao.TipoDescricao + ' Finalizada', 'Finalização executada com sucesso! Parabéns por mais uma empreitada concluída. : )',
                                        () => {
                                            $location.path('/');
                                        });
                                });

                        }
                    }
                );

            }
            , () => {
            });

    }

    $scope.reabrirConstrucao = () => {
        Construcao.reabrirConstrucao($scope.construcao.Id,
            (data) => {
                $location.path('/');
            });
    }

    $scope.$on('atualizaVersaoVigha', (event, args) => {
        Cliente.getVighaSourcer((data) => {
            var tot = data.Instance ? data.Instance.length : 0;
            data.Instance.forEach((d,i) => {
                fetch(d.Url, {
                    headers: {
                        "Pragma": "no-cache",
                        "Expires": -1,
                        "Cache-Control": "no-cache"
                    },
                }).then (() => {
                    if (i+1 >= tot) {
                        var sessao = CacheApp.getSessao();
                        sessao.UpdateAvailable = false;
                        CacheApp.setSessao(sessao);
                        window.location.reload(true);
                    }
                });
            });

            if (tot == 0) {
                var sessao = CacheApp.getSessao();
                sessao.UpdateAvailable = false;
                CacheApp.setSessao(sessao);
                window.location.reload();
            }
        });
    });

    $scope.plotaChart = function(plota) {
        var canvas = document.createElement('canvas');
        $(`#${plota.objName}`).html(canvas);
        var ctx = canvas.getContext("2d");

        var chart = new Chart(ctx, {
            type: plota.type,
            data: {
                labels: plota.labels,
                datasets: plota.dataSet
            },

            options: $scope.getOptionsLine(plota.titulo, plota.showLegend, plota.showYAxes, plota.showXAxes, plota.stackedBar)
        });                
    }

    $scope.getOptionsLine = function(titulo, showLegend, showYAxes, showXAxes, stackedBar) {
        var options = {
            showLines: true,
            maintainAspectRatio: false,
            legend: {
                display : showLegend
            },
            title: {
                display : titulo ? true : false,
                text: titulo ? titulo : '',
                fontSize: 18
            },

            scales: {
                yAxes: [{
                    display: showYAxes ? showYAxes : false,
                    gridLines: {
                        display: false
                    },
                    ticks: {
                        beginAtZero: stackedBar ? true : false
                    },
                }],
                xAxes: [{
                    display: showXAxes ? showXAxes : false,
                    gridLines: {
                        display: false
                    },
                    stacked: stackedBar ? true : false
                }],
            }
        }

        return options;
    }

    $scope.CopyText = (txt) => {
        var element = document.createElement('input');
        element.type = "text";
        element.setAttribute('value',txt);
        document.body.appendChild(element);
        element.select();
        document.execCommand("Copy");
        element.remove();
        swal({
            type: 'success',
            title: 'Link Copiado!',
            showConfirmButton: false,
            timer: 1000
        });
    }

    $scope.sendZapContato = () => {
        var msg = `Olá, sou ${$scope.sessao.Nome} e gostaria de tirar uma dúvida.`;
        window.open(`https://wa.me/5511910169085?text=${msg}`, '_blank');
    }

    $scope.detalharNota = (nota) => {
        Compra.getNotasFiscais(nota.IdConstrucao ? nota.IdConstrucao : $scope.construcao.Id, nota.IdNotaFiscal,
            (data) => {
                var notafiscal = data.Instance[0];
                CacheApp.setNotaFiscal(notafiscal);
                $location.path('/notafiscal/manter/' + (notafiscal.Natureza == 0 ? 'debito' : 'credito'));
        });
    };
    
    $scope.ativaNotificacaoWeb = () => {
        if ('Notification' in window) {
            Notification.requestPermission().then( (permission) => {
                console.log(permission)
                if (permission === 'granted') {
                    if ('serviceWorker' in navigator && 'PushManager' in window) {
                        navigator.serviceWorker.register('./view/Notificacao/worker.js', {
                            scope: './view/Notificacao/'
                        }).then(
                            (register) => {
                                console.log(register)
                                Notificacao.getNotificacaoConfig(
                                    (data) => {
                                        var params = {
                                            IdNotificacaoConfig: data.Instance.IdNotificacaoConfig
                                        }
                                        register.pushManager.subscribe({
                                                userVisibleOnly: true,
                                                applicationServerKey: configVighaInit.publicVapidKey
                                        }).then(
                                            (subscription) => {
                                                console.log(subscription)
                                                params.Subscription = JSON.stringify(subscription)
                                                Notificacao.ativaNotificacaoWeb(params,(data) => {})
                                            },
                                            (err) => {
                                                console.log(err)
                                            }
                                        )
                                    }
                                )
                            },
                            (err) => {
                                console.log(err)
                            }
                        );
                    }
                }

            });
        }
    }
    // $scope.ativaNotificacaoWeb()

}]);
